import { UserData, z } from '@mongodb-js/compass-user-data';
declare const RecentQuerySchema: z.ZodIntersection<z.ZodType<Omit<Partial<{
    filter: import("bson").Document;
    project: import("bson").Document;
    collation: import("bson").Document;
    sort: import("bson").Document;
    skip: number;
    limit: number;
    maxTimeMS: number;
}>, "maxTimeMS">, z.ZodTypeDef, Omit<Partial<{
    filter: import("bson").Document;
    project: import("bson").Document;
    collation: import("bson").Document;
    sort: import("bson").Document;
    skip: number;
    limit: number;
    maxTimeMS: number;
}>, "maxTimeMS">>, z.ZodObject<{
    _id: z.ZodString;
    _lastExecuted: z.ZodEffects<z.ZodUnion<[z.ZodDate, z.ZodNumber]>, Date, number | Date>;
    _ns: z.ZodString;
    _host: z.ZodOptional<z.ZodString>;
}, "strip", z.ZodTypeAny, {
    _id: string;
    _lastExecuted: Date;
    _ns: string;
    _host?: string | undefined;
}, {
    _id: string;
    _lastExecuted: (number | Date) & (number | Date | undefined);
    _ns: string;
    _host?: string | undefined;
}>>;
declare const FavoriteQuerySchema: z.ZodIntersection<z.ZodIntersection<z.ZodType<Omit<Partial<{
    filter: import("bson").Document;
    project: import("bson").Document;
    collation: import("bson").Document;
    sort: import("bson").Document;
    skip: number;
    limit: number;
    maxTimeMS: number;
}>, "maxTimeMS">, z.ZodTypeDef, Omit<Partial<{
    filter: import("bson").Document;
    project: import("bson").Document;
    collation: import("bson").Document;
    sort: import("bson").Document;
    skip: number;
    limit: number;
    maxTimeMS: number;
}>, "maxTimeMS">>, z.ZodObject<{
    _id: z.ZodString;
    _lastExecuted: z.ZodEffects<z.ZodUnion<[z.ZodDate, z.ZodNumber]>, Date, number | Date>;
    _ns: z.ZodString;
    _host: z.ZodOptional<z.ZodString>;
}, "strip", z.ZodTypeAny, {
    _id: string;
    _lastExecuted: Date;
    _ns: string;
    _host?: string | undefined;
}, {
    _id: string;
    _lastExecuted: (number | Date) & (number | Date | undefined);
    _ns: string;
    _host?: string | undefined;
}>>, z.ZodObject<{
    _name: z.ZodString;
    _dateModified: z.ZodEffects<z.ZodOptional<z.ZodUnion<[z.ZodDate, z.ZodNumber]>>, Date | undefined, number | Date | undefined>;
    _dateSaved: z.ZodEffects<z.ZodUnion<[z.ZodDate, z.ZodNumber]>, Date, number | Date>;
}, "strip", z.ZodTypeAny, {
    _name: string;
    _dateSaved: Date;
    _dateModified?: Date | undefined;
}, {
    _name: string;
    _dateSaved: (number | Date) & (number | Date | undefined);
    _dateModified?: number | Date | undefined;
}>>;
export type RecentQuery = z.output<typeof RecentQuerySchema>;
export type FavoriteQuery = z.output<typeof FavoriteQuerySchema>;
type QueryStorageOptions = {
    basepath?: string;
    namespace?: string;
};
export declare abstract class QueryStorage<T extends z.Schema> {
    protected readonly folder: string;
    protected readonly options: QueryStorageOptions;
    protected readonly userData: UserData<T>;
    constructor(schemaValidator: T, folder: string, options: QueryStorageOptions);
    loadAll(): Promise<z.output<T>[]>;
    updateAttributes(id: string, data: Partial<z.input<T>>): Promise<z.output<T>>;
    delete(id: string): Promise<boolean>;
}
export declare class RecentQueryStorage extends QueryStorage<typeof RecentQuerySchema> {
    private readonly maxAllowedQueries;
    constructor(options?: QueryStorageOptions);
    saveQuery(data: Omit<z.input<typeof RecentQuerySchema>, '_id' | '_lastExecuted'>): Promise<void>;
}
export declare class FavoriteQueryStorage extends QueryStorage<typeof FavoriteQuerySchema> {
    constructor(options?: QueryStorageOptions);
}
export {};
//# sourceMappingURL=query-storage.d.ts.map